/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/

package lsagpi;

import java.util.Vector;

/**
 * Clase que compara variables.
 * @author Miguel Angel Pescador Santirso
 */
public class Comparar {
    final int COLISION=0;
    final int EQ=1;
    final int EQI=2;
    final int EQR=3;
    final int EQS=4;
    final int EQSV=5;
    final int EQV=6;
    final int GE=7;
    final int GEV=8;
    final int GT=9;
    final int GTV=10;
    final int DENTRO=11;
    final int ESJUGADOR=12;
    final int LE=13;
    final int LEV=14;
    final int LT=15;
    final int LTV=16;
    final int NE=17;
    final int NEV=18;
    final int PRESENTE=19;
    final int COGIDO=20;
    final int AND=100;
    final int OR=101;
    final int NOT=102;
    int clasecomparacion;
    String operador1;
    String operador2;
    boolean respuesta=false;
    
    /**
     * Constructor de comparacion.
     * @param expresion Expresion a comparar.
     * @param cuarto habitacion actual.
     */
    public Comparar(Vector expresion,Cuarto cuarto){
        //System.out.println(expresion.get(0).toString());
        
        clasecomparacion=(new Integer(expresion.get(0).toString())).intValue();
        if(expresion.size()>1)
            operador1=expresion.get(1).toString();
        //System.out.println("Operador1: "+operador1);
        if(expresion.size()>2)
            operador2=expresion.get(2).toString();
        //System.out.println("Operador2: "+operador2);
        switch(clasecomparacion){
            case COLISION://Colision
                Elemento elemento1;
                Elemento elemento2;
                Vector elem=cuarto.elementos;
                int[] posi1 = null;
                int[] posi2 = null;
                int altoposi1= 0;
                int altoposi2= 0;
                int anchoposi1= 0;
                int anchoposi2= 0;
                for(int i=0;i<elem.size();i++){
                   // System.out.println("Elemento:"+((Elemento)elem.get(i)).nombre);
                    if(operador1.equals(((Elemento)elem.get(i)).nombre)){
                        elemento1=(Elemento)elem.get(i);
                        posi1=elemento1.getPosicion();
                        altoposi1 = elemento1.getImagen().getHeight(null);
                        anchoposi1 = elemento1.getImagen().getWidth(null);
                    }
                    if(operador2.toString().equals(((Elemento)elem.get(i)).nombre)){
                        elemento2=(Elemento)elem.get(i);
                        posi2=elemento2.getPosicion();
                        altoposi2 = elemento2.getImagen().getHeight(null);
                        anchoposi2 = elemento2.getImagen().getWidth(null);
                    }
                }
                //xy del primer elemento contenidos en el segundo
                if ( (posi1[0] < posi2[0] + anchoposi2) && (posi2[0] < posi1[0]+ anchoposi1) && (posi1[1] < posi2[1]+ altoposi2))
                 {
                    respuesta=(posi2[1] < (posi1[1] + altoposi1));
                 }else{respuesta=false;}
                    //xy del segundo elemento contenidos en el primero.
                    
                
                break;
            case EQ:    for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1+" = " + vari.get(j+1).toString()+"Operador2"+operador2);
                                int varint=Integer.parseInt(vari.get(j+1).toString());
                                if(varint==Integer.parseInt(operador2)){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case EQI:break;
            case EQR:break;
            case EQS: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                String varcadena=vari.get(j+1).toString();
                                if(varcadena.equals(operador2)){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case EQSV:  for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        String varcadena1=null;
                        String varcadena2=null;
                        if(!vari.isEmpty()){
                            // Rellenamos varcadena1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varcadena1=vari.get(j+1).toString();
                            }
                            }
                            //Rellenamos varcadena2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varcadena2=vari.get(j+1).toString();
                            }
                            }
                            // Comparamos las cadenas.
                            if(varcadena1.equals(varcadena2)){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }                    
                break;
            case EQV: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1==varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case GE:  for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1+" = " + vari.get(j+1).toString());
                                int varint=(new Integer(vari.get(j+1).toString())).intValue();
                                if(varint>=(new Integer(operador2)).intValue()){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case GEV:for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1>=varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case GT: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                int varint=(new Integer(vari.get(j+1).toString())).intValue();
                                if(varint>(new Integer(operador2)).intValue()){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case GTV:for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1>varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case DENTRO:break;
            case ESJUGADOR:
                if(operador1.equals(operador2)){
                respuesta=true;
            }else{respuesta=false;}
                break;
            case LE: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                int varint=(new Integer(vari.get(j+1).toString())).intValue();
                                if(varint<=(new Integer(operador2)).intValue()){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case LEV:for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1<=varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case LT: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                int varint=(new Integer(vari.get(j+1).toString())).intValue();
                                if(varint<(new Integer(operador2)).intValue()){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case LTV:for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1<varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case NE: for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        if(!vari.isEmpty()){
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                int varint=(new Integer(vari.get(j+1).toString())).intValue();
                                if(varint!=(new Integer(operador2)).intValue()){
                                    respuesta=true;
                                }
                                else{respuesta=false;}
                            }
                        }}
                    }
                break;
            case NEV:for(int i=0;i<cuarto.elementos.size();i++){
                        Vector vari=((Elemento)cuarto.elementos.elementAt(i)).variables;
                        int varint1=0;
                        int varint2=0;
                        if(!vari.isEmpty()){
                            // Rellenamos varint1
                            for (int j=0;j<vari.size();j++){
                            if (operador1.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador1);
                                varint1=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            //Rellenamos varint2
                            for (int j=0;j<vari.size();j++){
                            if (operador2.equals(vari.get(j).toString())){
                                System.out.println("Variable encontrada: "+operador2);
                                varint2=(new Integer(vari.get(j+1).toString())).intValue();
                            }
                            }
                            // Comparamos los enteros.
                            if(varint1!=varint2){
                                    respuesta=true;
                            }else{respuesta=false;}
                            }
                        }

                  break;
            case PRESENTE:break;
            case COGIDO:break;
        }}
    /**
     * Devuelve el resultado de la comparacion.
     * @return boolean resultado.
     */
    public boolean getResultado(){
        return respuesta;
    }
}
