/* LSAGPI                                       */
/* Desarrollado por Miguel Angel Pescador Santirso  */
/* mescadorsantirso@gmail.com                       */

/* LICENCIA X11/MIT
Copyright (c) 2010 Miguel Angel Pescador Santirso

Se autoriza, de forma gratuita, a cualquier
persona que ha obtenido una copia de este software y
archivos asociados de documentación (el "Software"), para tratar en el
Software sin restricción, incluyendo sin ninguna limitación en lo que concierne
los derechos para usar, copiar, modificar, fusionar, publicar,
distribuir, sublicenciar, y / o vender copias de este
Software, y para permitir a las personas que usan el Software para
hacerlo, con sujeción a las siguientes condiciones:

El aviso de copyright anterior y este aviso de permiso
se incluirá en todas las copias o partes sustanciales de
este Software.

EL SOFTWARE SE ENTREGA "TAL CUAL", SIN GARANTÍA DE NINGÚN
TIPO, EXPRESA o implícita, no limitado a la GARANTÍAS DE
COMERCIALIZACIÓN, CAPACIDAD DE HACER Y DE NO INFRACCIÓN DE COPYRIGHT. EN NINGÚN
CASO LOS AUTORES O TITULARES DEL COPYRIGHT SERÁN RESPONSABLES DE
NINGUNA RECLAMACIÓN, daños o OTRAS RESPONSABILIDADES,
YA SEA EN UN LITIGIO, agravio o DE OTRO MODO,
DERIVADAS DE, FUERA DE O EN CONEXION CON EL
SOFTWARE SU UTILIZACIÓN U OTRAS OPERACIONES EN EL SOFTWARE.
*/


package lsagpi;

import java.util.StringTokenizer;
import java.util.Vector;
import javax.swing.ImageIcon;

/**
 * Clase que parsea los Cuartos de la aventura.
 * @author Miguel Angel Pescador Santirso
 */
public class Cuarto {
String nombre;
ImageIcon Fondo;
ImageIcon Mascara;
Vector elementos=new Vector();
Vector acciones=new Vector();
Vector eventos=new Vector();
String sonidofondo=new String("");
Vector procedimiento=new Vector();

/**
 * Constructor del cuarto
 * @param definicion Definicion del cuarto.
 * @param nom Nombre del cuarto.
 */
    public Cuarto(String definicion, String nom){
        nombre=nom;
        StringTokenizer st = new StringTokenizer(definicion,"\n",true);
        //nombre=st.nextToken();
        while (st.hasMoreTokens())
		{
            String cadena=st.nextToken();
            //System.out.println(cadena);
            if(cadena.indexOf("ELEMENTO")!=-1){
                System.out.println("Un elemento");
                StringTokenizer nom_tok=new StringTokenizer(cadena);
                String nomb=new String("");
                nomb=nom_tok.nextToken();
                while(nomb.indexOf("ELEMENTO")==-1)
                        nomb=nom_tok.nextToken();
                if(nomb.equals("ELEMENTO")){
                       nomb=nom_tok.nextToken();
                }
                String elemento=new String("");
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                cadena=st.nextToken();
                int contador=0;
                elemento+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       elemento+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           elemento+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           elemento+=cadena_contador;
                       }
                    }
                    elementos.add(new Elemento(elemento,nomb));
           }
           if(cadena.indexOf("SONIDOFONDO")!=-1){
                System.out.println("Musica de Fondo");
                while(cadena.indexOf("\"")==-1){
                    cadena=st.nextToken();
                }
                StringTokenizer snd_tok=new StringTokenizer(cadena,"\"");
                snd_tok.nextToken();
                sonidofondo=snd_tok.nextToken();
                System.out.println(sonidofondo);
           }
           if(cadena.indexOf("IMAGEN")!=-1){
                System.out.println("Fondo de Pantalla");
                while(cadena.indexOf("\"")==-1){
                    cadena=st.nextToken();
                }
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                if(cadena.indexOf("{")!=-1 && cadena.indexOf("{")!=-1){
                    icon_tok.nextToken();
                    Fondo=new ImageIcon(icon_tok.nextToken());
                }else{

                while(icon_tok.hasMoreTokens()){
                    String temp=icon_tok.nextToken();
                    if(temp.trim().indexOf("{")!=-1){
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        Fondo=new ImageIcon(temp);                      
                    }else{
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        Fondo=new ImageIcon(temp);
                        }
                        
                }}
                System.out.println(Fondo.toString());
            }
            if(cadena.indexOf("MASCARA")!=-1){
                System.out.println("Mascara del fondo");
                while(cadena.indexOf("\"")==-1){
                    cadena=st.nextToken();
                }
                StringTokenizer icon_tok=new StringTokenizer(cadena,"\"");
                if(cadena.indexOf("{")!=-1 && cadena.indexOf("{")!=-1){
                    icon_tok.nextToken();
                    Mascara=new ImageIcon(icon_tok.nextToken());
                }else{

                while(icon_tok.hasMoreTokens()){
                    String temp=icon_tok.nextToken();
                    if(temp.trim().indexOf("{")!=-1){
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        Mascara=new ImageIcon(temp);
                    }else{
                        while(temp.trim().isEmpty() && icon_tok.hasMoreTokens())
                                temp=icon_tok.nextToken();
                        Mascara=new ImageIcon(temp);
                        }
                        
                }}
                System.out.println(Mascara.toString());
            }
           if(cadena.indexOf("INSTRUCCION")!=-1){
                System.out.println("Una instruccion de cuarto");
                String instruccion=new String("");
                int contador=0;
                instruccion+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           contador--;
                           instruccion+=cadena_contador;
                       }
                    }
                    acciones.add(new Accion(instruccion));
           }
            if(cadena.indexOf("PROCEDIMIENTO")!=-1){
                System.out.println("Un procedimiento");
                String instruccion=new String("");
                int contador=0;
                cadena=st.nextToken();
                while(cadena.indexOf("{")!=-1)
                    cadena=st.nextToken();
                cadena=st.nextToken();
                instruccion+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       instruccion+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           instruccion+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           instruccion+=cadena_contador;
                       }
                    }
                    procedimiento.add(new Accion(instruccion));
           }
            if(cadena.indexOf("EVENTO")!=-1){
                System.out.println("Un evento");
                int contador=0;
                while(cadena.indexOf("{")==-1){
                    cadena=st.nextToken();
                }
                String evento=new String("");
                evento+=cadena;
                while( contador!=(-1) && st.hasMoreTokens()){
                       String cadena_contador=st.nextToken();
                       evento+=cadena_contador;
                       if(cadena_contador.indexOf("{")!=-1){
                           contador++;
                           evento+=cadena_contador;
                       }
                       if(cadena_contador.indexOf("}")!=-1){
                           contador--;
                           evento+=cadena_contador;
                       }
                    }
                    eventos.add(new Evento(evento));
           }
           
                }
            }
    /**
     * Devuelve el nombre del cuarto.
     * @return String nombre.
     */
    public String getNombre(){
        return nombre;
    }
    /**
     * Devuelve la imagen de fondo del cuarto.
     * @return ImageIcon fondo.
     */
    public ImageIcon getFondo(){
        return Fondo;
    }
    /**
     * Devuelve la mascara de caminar del cuarto.
     * @return ImageIcon mascara.
     */
    public ImageIcon getMascara(){
        return Mascara;
    }
    /**
     * Devuelve el elemento en la posicion i del cuarto.
     * @param i posicion del elemento.
     * @return Elemento elemento.
     */
    public Elemento getElementoEn(int i){
        return (Elemento)elementos.elementAt(i);
    }
    /**
     * Devuelve el numero de elementos del cuarto.
     * @return int numero de elementos.
     */
    public int getNumeroElementos(){
        return elementos.size();
    }
}
